#include "stdafx.h"
#include "HDUSTest.h"
#include "BasicWindow.h"




CBasicWindow::CBasicWindow()
{
	m_hwnd=NULL;
	m_WindowPosition.Left=0;
	m_WindowPosition.Top=0;
	m_WindowPosition.Width=0;
	m_WindowPosition.Height=0;
}


CBasicWindow::~CBasicWindow()
{
	Destroy();
}


void CBasicWindow::Destroy()
{
	if (m_hwnd!=NULL)
		DestroyWindow(m_hwnd);
}


void CBasicWindow::SetPosition(int Left,int Top,int Width,int Height)
{
	if (m_hwnd!=NULL) {
		MoveWindow(m_hwnd,Left,Top,Width,Height,TRUE);
	} else {
		m_WindowPosition.Left=Left;
		m_WindowPosition.Top=Top;
		m_WindowPosition.Width=Width;
		m_WindowPosition.Height=Height;
	}
}


void CBasicWindow::GetPosition(int *pLeft,int *pTop,int *pWidth,int *pHeight) const
{
	if (m_hwnd!=NULL) {
		if ((GetWindowStyle(m_hwnd)&WS_CHILD)!=0) {
			RECT rc;

			GetWindowRect(m_hwnd,&rc);
			MapWindowPoints(m_hwnd,GetParent(m_hwnd),(LPPOINT)&rc,2);
			if (pLeft)
				*pLeft=rc.left;
			if (pTop)
				*pTop=rc.top;
			if (pWidth)
				*pWidth=rc.right-rc.left;
			if (pHeight)
				*pHeight=rc.bottom-rc.top;
		} else {
			WINDOWPLACEMENT wc;

			wc.length=sizeof(WINDOWPLACEMENT);
			GetWindowPlacement(m_hwnd,&wc);
			if (pLeft)
				*pLeft=wc.rcNormalPosition.left;
			if (pTop)
				*pTop=wc.rcNormalPosition.top;
			if (pWidth)
				*pWidth=wc.rcNormalPosition.right-wc.rcNormalPosition.left;
			if (pHeight)
				*pHeight=wc.rcNormalPosition.bottom-wc.rcNormalPosition.top;
		}
	} else {
		if (pLeft)
			*pLeft=m_WindowPosition.Left;
		if (pTop)
			*pTop=m_WindowPosition.Top;
		if (pWidth)
			*pWidth=m_WindowPosition.Width;
		if (pHeight)
			*pHeight=m_WindowPosition.Height;
	}
}


void CBasicWindow::SetVisible(bool fVisible)
{
	if (m_hwnd!=NULL)
		ShowWindow(m_hwnd,fVisible?SW_SHOW:SW_HIDE);
}


void CBasicWindow::OnDestroy()
{
	GetPosition(&m_WindowPosition.Left,&m_WindowPosition.Top,
				&m_WindowPosition.Width,&m_WindowPosition.Height);
	m_hwnd=NULL;
}
