#include "stdafx.h"
#include "ChannelList.h"




class CChannelInfo {
public:
	CChannelInfo(int Space,int Channel,int No,LPCTSTR pszName);
	int m_Space;
	int m_Channel;
	int m_ChannelNo;
	TCHAR m_szName[MAX_CHANNEL_NAME];
};


CChannelInfo::CChannelInfo(int Space,int Channel,int No,LPCTSTR pszName)
{
	m_Space=Space;
	m_Channel=Channel;
	m_ChannelNo=No;
	lstrcpyn(m_szName,pszName,MAX_CHANNEL_NAME);
}




CChannelList::CChannelList()
{
	m_NumChannels=0;
	m_ppList=NULL;
	m_ChannelOffset=0;
}


CChannelList::~CChannelList()
{
	int i;

	for (i=m_NumChannels-1;i>=0;i--)
		delete m_ppList[i];
	free(m_ppList);
}


bool CChannelList::AddChannel(int Space,int Channel,int No,LPCTSTR pszName)
{
	m_ppList=(CChannelInfo**)realloc(m_ppList,
									(m_NumChannels+1)*sizeof(CChannelInfo*));
	m_ppList[m_NumChannels++]=new CChannelInfo(Space,Channel,No,pszName);
	return true;
}


int CChannelList::GetSpace(int No) const
{
	if (No<0 || No>=m_NumChannels)
		return -1;
	return m_ppList[No]->m_Space;
}


int CChannelList::GetChannel(int No) const
{
	if (No<0 || No>=m_NumChannels)
		return -1;
	return m_ppList[No]->m_Channel;
}


int CChannelList::GetChannelNo(int No) const
{
	if (No<0 || No>=m_NumChannels)
		return -1;
	return m_ppList[No]->m_ChannelNo;
}


int CChannelList::GetChannelIndex(int No) const
{
	int Index;

	if (No<0 || No>=m_NumChannels)
		return -1;
	Index=m_ppList[No]->m_Channel-m_ChannelOffset;
	return Index;
}


LPCTSTR CChannelList::GetName(int No) const
{
	if (No<0 || No>=m_NumChannels)
		return TEXT("");
	return m_ppList[No]->m_szName;
}


bool CChannelList::SetChannelOffset(int Offset)
{
	m_ChannelOffset=Offset;
	return true;
}


void CChannelList::Clear()
{
	if (m_NumChannels>0) {
		int i;

		for (i=m_NumChannels-1;i>=0;i--)
			delete m_ppList[i];
		free(m_ppList);
		m_NumChannels=0;
		m_ppList=NULL;
	}
}


int CChannelList::FindChannelNo(int No) const
{
	int i;

	for (i=0;i<m_NumChannels;i++) {
		if (m_ppList[i]->m_ChannelNo==No)
			return i;
	}
	return -1;
}


int CChannelList::GetNextChannelNo(int ChannelNo,bool fWrap) const
{
	int i;
	int Channel,Min,No;

	Channel=1000;
	Min=1000;
	for (i=0;i<m_NumChannels;i++) {
		No=GetChannelNo(i);
		if (No>ChannelNo && No<Channel)
			Channel=No;
		if (No<Min)
			Min=No;
	}
	if (Channel==1000) {
		if (fWrap)
			return Min;
		return 0;
	}
	return Channel;
}


int CChannelList::GetPrevChannelNo(int ChannelNo,bool fWrap) const
{
	int i;
	int Channel,Max,No;

	Channel=0;
	Max=0;
	for (i=0;i<m_NumChannels;i++) {
		No=GetChannelNo(i);
		if (No<ChannelNo && No>Channel)
			Channel=No;
		if (No>Max)
			Max=No;
	}
	if (Channel==0) {
		if (fWrap)
			return Max;
		return 0;
	}
	return Channel;
}
