#include "stdafx.h"
#include <math.h>
#include <shlwapi.h>
#include "Util.h"




LPSTR DuplicateStringA(LPCSTR pszString)
{
	LPSTR p;

	p=new char[lstrlenA(pszString)+1];
	lstrcpyA(p,pszString);
	return p;
}


LPWSTR DuplicateStringW(LPCWSTR pszString)
{
	LPWSTR p;

	p=new WCHAR[lstrlenW(pszString)+1];
	lstrcpyW(p,pszString);
	return p;
}


float LevelToDeciBel(int Level)
{
	float Volume;

	if (Level==0)
		Volume=-100.0f;
	else
		Volume=(float)(20.0*log10((double)Level/100.0));
	return Volume;
}


DWORD DiffTime(DWORD Start,DWORD End)
{
	if (Start<End)
		return End-Start;
	return (0xFFFFFFFFUL-Start+1)+End;
}


FILETIME &operator+=(FILETIME &ft,LONGLONG Offset)
{
	ULARGE_INTEGER Result;

	Result.LowPart=ft.dwLowDateTime;
	Result.HighPart=ft.dwHighDateTime;
	Result.QuadPart+=Offset;
	ft.dwLowDateTime=Result.LowPart;
	ft.dwHighDateTime=Result.HighPart;
	return ft;
}


void EnableDlgItem(HWND hDlg,int ID,bool fEnable)
{
	EnableWindow(GetDlgItem(hDlg,ID),fEnable);
}


void EnableDlgItems(HWND hDlg,int FirstID,int LastID,bool fEnable)
{
	int i;

	if (FirstID>LastID) {
		i=FirstID;
		FirstID=LastID;
		LastID=i;
	}
	for (i=FirstID;i<=LastID;i++)
		EnableDlgItem(hDlg,i,fEnable);
}


bool ChooseFontDialog(HWND hwndOwner,LOGFONT *plf)
{
	CHOOSEFONT cf;

	cf.lStructSize=sizeof(CHOOSEFONT);
	cf.hwndOwner=hwndOwner;
	cf.lpLogFont=plf;
	cf.Flags=CF_FORCEFONTEXIST | CF_INITTOLOGFONTSTRUCT | CF_SCREENFONTS;
	return ChooseFont(&cf)!=FALSE;
}


int CALLBACK BrowseFolderCallback(HWND hwnd,UINT uMsg,LPARAM lpData,
																LPARAM lParam)
{
	switch (uMsg) {
	case BFFM_INITIALIZED:
		if (((LPTSTR)lParam)[0]!='\0') {
			TCHAR szDirectory[MAX_PATH];

			lstrcpy(szDirectory,(LPTSTR)lParam);
			PathRemoveBackslash(szDirectory);
			SendMessage(hwnd,BFFM_SETSELECTION,TRUE,(LPARAM)szDirectory);
		}
		break;
	}
	return 0;
}


bool BrowseFolderDialog(HWND hwndOwner,LPTSTR pszDirectory,LPCTSTR pszTitle)
{
	BROWSEINFO bi;
	ITEMIDLIST *pidl;
	BOOL fRet;

	bi.hwndOwner=hwndOwner;
	bi.pidlRoot=NULL;
	bi.pszDisplayName=pszDirectory;
	bi.lpszTitle=pszTitle;
	bi.ulFlags=BIF_RETURNONLYFSDIRS;
	bi.lpfn=BrowseFolderCallback;
	bi.lParam=(LPARAM)pszDirectory;
	pidl=SHBrowseForFolder(&bi);
	if (pidl==NULL)
		return false;
	fRet=SHGetPathFromIDList(pidl,pszDirectory);
	CoTaskMemFree(pidl);
	return fRet==TRUE;
}
